# coding: utf-8
u'''
Основной грид реестра циклов по курсам.

'''

# from java.text import SimpleDateFormat
import json
# from java.sql import Timestamp
from medstaff._medstaff_orm import vw_student_programCursor, student_programCursor
from common.sysfunctions import toHexForXml, getGridHeight
from edu._edu_orm import course_edu_baseCursor, course_edu_formCursor
from nci._nci_orm import education_baseCursor, education_formCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
# from security.functions import userHasPermission
from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid

from gridsettings.functions.gridSettings import toolbar_button_default,toolbar_button, get_column_meta,\
    get_column_data, get_column_header
from gridsettings._gridsettings_orm import grid_fieldCursor, user_grid_fieldCursor
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def gridData(context, main, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None, firstrecord=None, pagesize=None):
    session = json.loads(session)['sessioncontext']
    sid = session['sid']
    vw_student_program = vw_student_programCursor(context)
    course_edu_base = course_edu_baseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    edu_form = education_formCursor(context)
    education_base = education_baseCursor(context)
    grid_field = grid_fieldCursor(context)
    user_grid_field = user_grid_fieldCursor(context)
    # Заголовки
    _header = {
        'uid': ['~~id','id'],
        'properties': [u'properties', 'properties']}    
    
    _header.update(get_column_header(grid_field,user_grid_field,elementId,sid))

    person_id = getPersonIdBySid(context, sid)

    vw_student_program.setRange('person_id',person_id)
    # Статус - Проходит обучение
    if main == 'active':
        status_id = 20
    elif main == 'completed':
        status_id = 21
    else:
        status_id = -1
    
    vw_student_program.setRange('status_id', status_id)
    
    
    vw_student_program.limit(firstrecord - 1, pagesize)

    grid_data = {'records': {'rec': []}}
    
    for column in _header:
        _header[column].append(toHexForXml(_header[column][0]))    

    for vw_student_program in vw_student_program.iterate():
        cource_id = vw_student_program.course_id
        row = {}
        row[_header['uid'][2]] = vw_student_program.certificate
        course_edu_base.setRange('course_id', cource_id)
        edu_base_names = []
        for course_edu_base in course_edu_base.iterate():
            education_base.get(course_edu_base.edu_base_id)
            edu_base_names.append(education_base.name)
            
        u"""Название формы обучения"""
        edu_form_name = ""
        
        u"""Получение названия формы обучения"""
        course_edu_form.setRange("course_id",cource_id)
        for form in course_edu_form.iterate():
            edu_form.get(form.edu_form_id)
            edu_form_name += edu_form.name + ", "
        edu_form_name = edu_form_name[:-2]#отсечение последней запятой и пробела
            
        add_data = {'name':{'div':{'ins':{'font':{"@style": "cursor: pointer",
                                                  '@color':'blue',
                                                  "@title": vw_student_program.name,
                                                 '#text': vw_student_program.name}}}},
                    'edu_org_shortname':{'div':{'ins':{'font':{"@style": "cursor: pointer",
                                                  '@color':'blue',
                                                  "@title": u"Просмотреть подробную информацию об образовательной организации",
                                                 '#text':vw_student_program.edu_org_shortname}}}},
                    'edu_base':','.join(edu_base_names),
                    "education_form_name": edu_form_name,
                    'program_link':{'div':{'a':{'@href':vw_student_program.program_link,
                                                '#text':vw_student_program.program_link}}}}
        get_column_data(_header, grid_field, user_grid_field, elementId, sid, vw_student_program, row, **add_data)

        if 'dot_eo' in _header:
            row[_header['dot_eo'][2]] += u':С применением дистанционных образовательных технологий и электронного обучения'
        row[_header['properties'][2]] =  {'event': []}
        if 'info' in _header:
            row[_header['properties'][2]]['event'].append( {
                            '@name': 'cell_single_click',
                            '@column': _header['info'][0],
                            'action': {
                                '@show_in': 'MODAL_WINDOW',
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'modalwindow': {
                                        '@caption': u'Подача заявки',
                                        '@height': '700',
                                        '@width': '700'}},
                                    {'datapanel': {
                                        '@type': 'current',
                                        '@tab': 'current',
                                        'element': {
                                            '@id': 'downloadCertificateFromCertCard',
                                            'add_context': 'download'}}}]}}) 

        if 'name' in _header:
            row[_header['properties'][2]]['event'].append( {
                            '@name': 'cell_single_click',
                            '@column': _header['name'][0],
                            'action': {
                                '@show_in': 'MODAL_WINDOW',
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'modalwindow': {
                                        '@caption': u'Сведения о программе',
                                        '@height': '570',
                                        '@width': '660'}},
                                        {'datapanel': {
                                            '@type': 'current',
                                            '@tab': 'current',
                                            'element': {
                                                '@id': 'courseCardInfo',
                                                'add_context': 'infoCard'}}}]}})                 
        if 'edu_org_shortname' in _header:
            row[_header['properties'][2]]['event'].append( {
                            '@name': 'cell_single_click',
                            '@column': _header['edu_org_shortname'][0],
                            'action': {
                                '@show_in': 'MODAL_WINDOW',
                                '#sorted': [
                                    {'main_context': 'current'},
                                    {'modalwindow': {
                                        '@caption': u'Информация об образовательной организации',
                                        '@height': '700',
                                        '@width': '660'}},
                                    {'datapanel': {
                                        '@type': 'current',
                                        '@tab': 'current',
                                        'element': {
                                            '@id': 'eduOrgInfoCard'}}}]}})                 
        
        grid_data['records']['rec'].append(row)
        
    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(grid_data)), None)


def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    sid = JsonPath.read(session, "$.sessioncontext.sid")
    person_id = getPersonIdBySid(context, sid)
    session = json.loads(session)
#     student_program = student_programCursor(context)
#     selected_id = None
#     if add and student_program.tryGet(person_id,add):
#         selected_id = add
#     if main and main != 'current' and student_program.tryGet(person_id,main):
#         selected_id = main
    vw_student_program = vw_student_programCursor(context)
    vw_student_program.setRange('person_id',person_id)
    # Статус - Проходит обучение
    vw_student_program.setRange('status_id', 20)

#     filter_string = ''
#     if context.getData().get('dpppkFilter',''):
#         filter_string = ext_filter(context.getData()['dpppkFilter'],programCycle,context)
    grid_settings = {}
    grid_settings['gridsettings'] = {
#         'labels': {
#             'header': 'Мои циклы<br>' + filter_string
#         },
        'columns': {'col': get_column_meta(context,elementId,sid)},
        'properties': {
            '@pagesize': 50,
            '@gridWidth': '100%',
            '@gridHeight': getGridHeight(session, numberOfGrids=1, gridHeaderHeight=55, delta=180),
            '@totalCount': vw_student_program.count(),
            '@fireGeneralAndConcreteEvents':'true',
            '@profile': 'default.properties'}}

#     if selected_id:
#         grid_settings['gridsettings']['properties']['@autoSelectRecordUID'] = selected_id
#     else:
#         grid_settings['gridsettings']['properties']['@autoSelectRecordId'] = 1
        
    return JythonDTO(None,
                     XMLJSONConverter.jsonToXml(json.dumps(grid_settings)))


def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):

    session_json = json.loads(session)['sessioncontext']
    sid = session_json['sid']
    grid_context = session_json['related']['gridContext']

    if 'currentRecordId' in grid_context:
        disable = 'false'
        currRec = grid_context["currentRecordId"]
    else:
        disable = 'true'
        currRec = ''

    grid_toolbar = {
        'gridtoolbar': {
            '#sorted': [
                toolbar_button(context, sid, elementId),
                toolbar_button_default(context, sid, elementId)]}}
#                 filter_button('dpppkFilter',800,700),
#                 filter_reset_button(elementId, 'dpppkFilter'),
    if main == 'active':
        grid_toolbar['gridtoolbar']['#sorted'].append(
                {'item': {
                    '@text': u'Перейти',
                    '@hint': u'Перейти к программе',
                    '@disable': disable,
                    'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'navigator': {
                                '@element': 'certificate-{}'.format(currRec),
                                '@refresh': 'true'}},
                            {'server' : {
                                'activity' : {
                                    '@id': "addOpenedCycle", 
                                    '@name': "medstaff.other.serverActions.addOpenedCycle.celesta",
                                    'add_context': currRec}}}]}}})

    return XMLJSONConverter.jsonToXml(json.dumps(grid_toolbar))
