# coding: utf-8
'''
'''
import json

# from ru.curs.celesta.showcase.utils import XMLJSONConverter
import security.functions as secfun
from medstaff._medstaff_orm import vw_student_programCursor,\
    student_cycleCursor, student_eor_tasksCursor
from nci.functions.persons import getPersonIdBySid
from edu._edu_orm import course_cycleCursor
from nci import generalSettings


def navMedStaff(context, session):
    u'''Навигатор кабинета медработника.'''

    sid = json.loads(session)['sessioncontext']['sid']
    resultJSON = {
        "group": [
            {"@id": "medStaffNavigator",
            "@name": u"Личный кабинет",
            "level1": [
              {'@id': 'generalInfo',
              '@selectOnLoad': 'true',
              '@name': u'Общая информация',
              'action': {
                  '#sorted': [
                      {'main_context': 'current'},
                      {'datapanel': {
                          '@type': 'medstaff.datapanel.generalInfo.datapanel.cl',
                          '@tab': 'firstOrCurrent'}}]}}]},
            {"@id": "medStaffPrograms",
            "@name": u"Мои программы",
            "level1": []}]}
    
    '''Проверка разрешений на формирование навигатора'''
    if secfun.userHasPermission(context, sid, 'medStaffPersonalData'):
        resultJSON['group'][0]['level1'].append({
            '@id': 'medStaffPersonalData',
            '@selectOnLoad': 'false',
            '@name': u'Личные сведения',
            'action': {
                '#sorted': [
                    {'main_context': 'current'},
                    {'datapanel': {
                        '@type': 'medstaff.datapanel.personalDataDatapanel.datapanel.cl',
                        '@tab': 'firstOrCurrent'}}]}})


    if secfun.userHasPermission(context, sid, 'medStaffCycleCatalog'):
        resultJSON['group'][0]['level1'].append({
            '@id': 'catalogDpppk',
            '@name': u'Перечень программ',
            'action': {
                '#sorted': [
                    {'main_context': 'current'},
                    {'datapanel': {
                        '@type': 'medstaff.datapanel.dpppkCyclesDatapanel.datapanel.cl',
                        '@tab': 'firstOrCurrent'}}]}})
                        
    if secfun.userHasPermission(context, sid, 'medStaffCertificates'):        
        medstaffRequests = {
            '@id': 'medstaffRequests',
            '@name': u'Заявки на программы',
            'action': {
                '#sorted': [
                    {'main_context': 'current'},
                    {'datapanel': {
                        '@type': 'medstaff.datapanel.certificatesDatapanel.datapanelRequests.cl',
                        '@tab': 'firstOrCurrent'}}]}}
        
        resultJSON['group'][1]['level1'].append(medstaffRequests)
        
        medStaffCertificates = {
            '@id': 'listCertificates',
            '@name': u'Активные программы',
            '#sorted': [
                {'action': {
                    '#sorted': [
                        {'main_context': 'active'},
                        {'datapanel': {
                            '@type': 'medstaff.datapanel.certificatesDatapanel.datapanel.cl',
                            '@tab': 'firstOrCurrent'}}]}}]}
        # Цикл по открытым на просмотр курсам
        student_program_open = vw_student_programCursor(context)
        person_id = getPersonIdBySid(context, sid)
        student_program_open.setRange('person_id', person_id)
        # Статус - Проходит обучение
        student_program_open.setRange('status_id', 20)
        
        student_cycle_open = student_cycleCursor(context)
        student_cycle_open.setRange('person_id', person_id)
#         student_cycle_open.setRange('cycle_open', True)

        course_cycle = course_cycleCursor(context)
        
        coursesOpen = []        
        for courseOpenItem in student_program_open.iterate():
            courseId = courseOpenItem.course_id
            certificate = courseOpenItem.certificate
            courseOpen = {
                '@id': 'certificate-{}'.format(certificate),
                '@name': courseOpenItem.name,
                '#sorted': [
                    {'action': {
                        '#sorted': [
                            {'main_context': json.dumps({"courseId": courseId, "certificate": certificate})},
                            {'datapanel': {
                                '@type': 'medstaff.datapanel.certificatesDatapanel.datapanelProgram.cl',
                                '@tab': 'firstOrCurrent',
                                'element': {
                                    '@id': 'courseCardInfo',
                                    'add_context': 'info'}}}]}}]}
            
            student_cycle_open.setRange('course_id', courseId)
            student_cycle_open.setRange('student_certificate', certificate)
            student_cycle_open.orderBy('cycle_order')
            cyclesOpen = []
            for cycleOpenItem in student_cycle_open.iterate():
                cycle_id = cycleOpenItem.cycle_id
                cycleOpenItem.cycle_open = checkThemeEnabled(context, session, courseId, cycle_id, certificate)
                cycleOpenItem.update()
                if cycleOpenItem.cycle_open:
                    course_cycle.get(cycle_id)
                    cycleOpen = {
                        '@id': 'cycle-{}'.format(certificate),
                        '@name': course_cycle.note,
                        'action': {
                            '#sorted': [
                                {'main_context': json.dumps({"cycle_id": cycle_id, "certificate": certificate})},
                                {'datapanel': {
                                    '@type': 'medstaff.datapanel.certificatesDatapanel.datapanelCycle.cl',
                                    '@tab': 'firstOrCurrent'}}]}}
        
                    cyclesOpen.append(cycleOpen)
            if cyclesOpen:
                courseOpen['#sorted'].append({'level3': cyclesOpen})
            
            coursesOpen.append(courseOpen)
        
        student_cycle_open.close()
        student_program_open.close()

        if coursesOpen:
            medStaffCertificates['#sorted'].append({'level2': coursesOpen})
        
        resultJSON['group'][1]['level1'].append(medStaffCertificates)
        
        medStaffCompleted = {
            '@id': 'medStaffCompleted',
            '@name': u'Завершенные программы',
            '#sorted': [
                {'action': {
                    '#sorted': [
                        {'main_context': 'completed'},
                        {'datapanel': {
                            '@type': 'medstaff.datapanel.certificatesDatapanel.datapanelCompleted.cl',
                            '@tab': 'firstOrCurrent'}}]}}]}
        
        resultJSON['group'][1]['level1'].append(medStaffCompleted)
                        
    # if secfun.userHasPermission(context, sid, 'currentAccredCycles'):
        # resultJSON['group']['level1'].append({
            # '@id': 'currentAccredCycles',
            # '@name': 'Индивидуальные циклы НПР',
            # 'action': {
                # 'main_context': 'current',
                # 'datapanel': {
                    # '@type': 'medstaff.datapanel.accreditationCyclesDatapanel.datapanel.cl',
                    # '@tab': 'firstOrCurrent'
                # }
            # }
        # })
    # if secfun.userHasPermission(context, sid, 'accredEvents'):
        # resultJSON['group']['level1'].append({
            # '@id': 'accredEvents',
            # '@name': 'Мероприятия аккредитации',
            # # 'action': {
            # #     'main_context': 'current',
            # #     'datapanel': {
            # #         '@type': 'nci.datapanel.eduOrganizationDatapanel.datapanel.cl',
            # #         '@tab': 'firstOrCurrent'
            # #     }
            # # }
        # })
    # if secfun.userHasPermission(context, sid, 'medStaffCommonSchedule'):
        # resultJSON['group']['level1'].append({
            # '@id': 'medStaffCommonSchedule',
            # '@name': 'Общее расписание',
            # '@selectOnLoad': 'true',
            # 'action': {
                # 'main_context': 'current',
                # 'datapanel': {
                    # '@type': 'medstaff.datapanel.commonScheduleDatapanel.datapanel.cl',
                    # '@tab': 'firstOrCurrent'
                # }
            # }
        # })
    # if secfun.userHasPermission(context, sid, 'medStaffEduPortfolio'):
        # resultJSON['group']['level1'].append({
            # '@id': 'medStaffEduPortfolio',
            # '@name': 'Образовательное портфолио',
            # 'action': {
                # 'main_context': 'current',
                # 'datapanel': {
                    # '@type': 'medstaff.datapanel.portfolioDatapanel.datapanel.cl',
                    # '@tab': 'firstOrCurrent'
                # }
            # }
        # })

    if (not resultJSON['group'][0]['level1']) and (not resultJSON['group'][1]['level1']):
        context.error(u"Отсутствуют разрешения для работы с системой. Обратитесь к администратору.")
        resultJSON = {"group": None}
#     raise Exception (XMLJSONConverter.jsonToXml(json.dumps(resultJSON)))
    return resultJSON


def navWidth(context, session):
    return {"@width": "205px",
            "@hideOnLoad": "false"}
    
def checkThemeEnabled(context, session, course_id, theme_id, certificate):
    u'''Фукнция проверки доступности темы'''
    ss = json.loads(session)['sessioncontext']
    sid = ss['sid']
    person_id = getPersonIdBySid(context, sid)
    
    student_cycle = student_cycleCursor(context)
    qti = student_eor_tasksCursor(context)
    
    cycle_order = 0    
    if student_cycle.tryGet(person_id, course_id, theme_id, certificate):
        cycle_order = student_cycle.cycle_order
    
    student_cycle.setRange('person_id', person_id)
    student_cycle.setRange('course_id', course_id)
    student_cycle.setRange('student_certificate', certificate)
    student_cycle.setFilter('cycle_order', '<{}'.format(cycle_order))
    student_cycle.orderBy('cycle_order DESC')
    NEXT_THEME_PERCENTAGE = int(generalSettings.getGlobalSettings(context, 'NEXT_THEME_PERCENTAGE'))
    score = []   
    
    if student_cycle.tryFirst():
        if student_cycle.cycle_open:
            qti.setRange('student_certificate', certificate)
            qti.setRange('cycle_id', student_cycle.cycle_id)
            for qti_item in qti.iterate():
                item_score = qti_item.score
                score.append(item_score if item_score else 0)
        else:
            return False
            
    qti.close()
    student_cycle.close() 
           
    if (not score) or (score and (min(score) >= NEXT_THEME_PERCENTAGE)):
        return True
    else:
        return False
