# coding: utf-8

from java.text import SimpleDateFormat
import json

from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO



def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка цикла аккредитации'''
    if context.getData().get(elementId,''):
        xformsdata = context.getData()[elementId]
    else:

        sid = JsonPath.read(session, "$.sessioncontext.sid")
        # определяем идентификатор ФЛ по sid
        person_id = getPersonIdBySid(context, sid)
    
    
        df = SimpleDateFormat("dd.MM.yyyy")
    
        bool_values = [{"label":u'Да',
                        "value":'true'},
                       {"label":u'Нет',
                        "value":'false'},
                       {"label":u'Все',
                        'value':'-'}]
    
        xformsdata = {"schema":
                          {"@xmlns": "",
                           "record":
                                {
                               'edu_organization_id':'',
                               'edu_organization_name':'',
                               'speciality_id':'',
                               'speciality_name':'',
                               'name':'',
                               'dateTo':'',
                               'dateFrom':'',
                               'dot_eo':'-',
                               'cost_from':'',
                               'cost_to':'',
                               'certificate':'-',
                               'simulation':'-',
                               'intern':'-',
                               'bool_values':bool_values,
                               'sim_hours':'',
                               'intern_hours':'',
                               'hours_from':'',
                               'hours_to':'',
                               'hours_sim_from':'',
                               'hours_sim_to':'',
                               'hours_intern_from':'',
                               'hours_intern_to':'',
                               'edu_form_id':'',
                               'edu_form_name':'',
                               'edu_form':'',
                               'edu_base':'',
                                "@filter":'1'
                                }
                            }
                          }



    xformssettings = {"properties":{
                        "event":[{"@name":"single_click",
                                  "@linkId": "1",
                                  "action":{
                                    '#sorted': [
                                      {"main_context": "current"},
                                      {"datapanel": {"@type": "current",
                                                    "@tab": "current",
                                                    "element": {"@id":"dpppkCyclesCatalogGrid",
                                                                "add_context": ""}
                                                     }}]
                                  }
                                }]
                           }
                      }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, xformsdata=None):
    context.getData()[elementId] = json.loads(xformsdata)
