# coding: utf-8
'''
Created on 15 дек. 2017 г.

@author: dgulyakin
'''
import json
from uuid import uuid4
from java.util import Date
from java.sql import Timestamp
from java.text import SimpleDateFormat
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from qt.functions import createTestingVariantAssign, generateVariant,\
    getAttributeValue, setTestTimeByParam
from java.io import OutputStreamWriter
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO
try:
    from org.apache.commons.lang3.StringEscapeUtils import unescapeHtml4
except:
    pass
from edu.constants import *
from dirusing.commonfunctions import relatedTableCursorImport
from nci import generalSettings
from qt._qt_orm import QtiVariantAnswerCursor, QtiThemeCursor, QtiQuestionCursor,\
    QtiDestructorCursor, QtiVariantParamsCursor, QtiVariantCursor
from nci.functions.persons import getPersonIdBySid
from medstaff._medstaff_orm import student_eor_tasksCursor,\
    practical_filesCursor


def taskData(context, main=None, add=None, filterinfo=None, session=None, elementId=None): 
    ss = json.loads(session)['sessioncontext']
    sid = ss['sid']
    person_id = getPersonIdBySid(context, sid)

    data = None
    
    # Первоначальная xformssettings
    xformssettings = {'properties': {}}
    
    taskCur = student_eor_tasksCursor(context)
    task_id = int(elementId.split('-')[1])
    if taskCur.tryGet(task_id):
        package_id = taskCur.package_id
        name = taskCur.package_name
        eor_type = taskCur.eor_type
        control_type = taskCur.control_type
        type_name = EOR_TYPE[eor_type][0]
        index = taskCur.qti_order
        currentTable = relatedTableCursorImport(EOR_TYPE[eor_type][1], EOR_TYPE[eor_type][2])(context)

    
        data = {'eor_type': eor_type,
                'index': index,
                'name': name,
                'open': 1 if (index == 1) or (add == 'refresh') or (add == 'delete') else 0,
                'type_name': type_name,
                'task_id': task_id} 
        
        if eor_type == TEST:
            # Тест
            variantCur = QtiVariantAnswerCursor(context)
            variantCur.setRange('VariantID', taskCur.variant_id) 
            if variantCur.tryFirst():
                testing_mark = variantCur.TestingMark
                time_begin = variantCur.TimeBegin
                time_end = variantCur.TimeEnd
                time_finish = variantCur.TimeFinish
                positive_count = variantCur.PositiveCount
                taskCur.score = variantCur.TestingMark
                taskCur.score_date = variantCur.TimeFinish
                score = variantCur.Score
                taskCur.update()
            else:
                testing_mark = None
                time_begin = None
                time_end = None
                time_finish = None
                positive_count = None
                score = None
            
            dateFormat = SimpleDateFormat("dd.MM.yyyy HH:mm")

            data["control_type_id"] = control_type
            data["control_type"] = CONTROL_TYPE[control_type]
            data["testing_mark"] = testing_mark
            data["time_begin"] = dateFormat.format(time_begin) if time_begin else None
            data["time_end"] = dateFormat.format(time_end) if time_end else None
            data["time_finish"] = dateFormat.format(time_finish) if time_finish else None
            data["score"] = score
            data["positive_count"] = positive_count
            data["variant_name"] = taskCur.variant_name
            data["attempts_count"] = taskCur.attempts_count
            data["test_enabled"] = 'false'
            data["attempt_time"] = u'Тест недоступен'
            
            if data["attempts_count"] > 0:
                data["test_enabled"] = 'true'
                data["attempt_time"] = u'Пройти тест'
                if time_begin:
                    if time_finish:
                        TEST_ATTEMPT_ENABLE = int(generalSettings.getGlobalSettings(context, 'TEST_ATTEMPT_ENABLE'))
                        FINAL_TEST_ATTEMPT_ENABLE = int(generalSettings.getGlobalSettings(context, 'FINAL_TEST_ATTEMPT_ENABLE'))
                                   
                        current_time = (Date().getTime() - time_begin.getTime()) / 60000
                        if control_type == FINAL:
                            p = FINAL_TEST_ATTEMPT_ENABLE * 60
                        else:
                            p = TEST_ATTEMPT_ENABLE
                        t = p - current_time
                        h = t // 60
                        m = t % 60
                        hh = u'{} час.'.format(h) if h>0 else u'' 
                        mm = u'{} мин.'.format(m) if m>0 else u''
                        if p > current_time:
                            data["attempt_time"] =  u'Тест будет доступен через {} {}'.format(hh, mm)
                            data["test_enabled"] = 'false'
                    else:
                        data["attempt_time"] = u'Продолжить тест'
            
            
            modeId = 'test'
            variant_id = taskCur.variant_id
            param = "continue"
            if not variant_id or time_finish:
                variant_id = unicode(uuid4())
                param = "create"
            
            data['mode_name'] = ''
            data['mode_id'] = modeId
            data['variant_id'] = variant_id
            data['package_id'] = package_id
            data['person_id'] = person_id
            data['param'] = param
                        
            xformssettings = {  
                'properties': {  
                    'event': [  
                        {'@name': 'single_click',
                         '@linkId': '1',
                         'action': {
                             "#sorted": [
                                {'main_context': 'current'},                
                                {'datapanel': {  
                                    '@type': 'current',
                                    '@tab': 'current',
                                    'element': [  
                                        {'@id': elementId,
                                         'add_context': 'refresh'}]}},
                                        {"client": {
                                            "activity":[
                                                {"@id": "debugBTZ",
                                                 "@name": "goToTest",
                                                 "add_context": u"&mode=%s&package=%s&param=%s" % (modeId, package_id, variant_id)}
#                                                 {"@id": "debugBTZ",
#                                                  "@name": "gotoLink",
#                                                  "add_context": json.dumps({'url': u"&mode=%s&package=%s&param=%s" % (modeId, package_id, variant_id),
#                                                                             'inside': 'false',
#                                                                             'target': ''})}
                                                ]}}]}}]}}
                
        elif eor_type == LECTURE:
            # Лекция
            if currentTable.tryGet(package_id):
                data['ref'] = getattr(currentTable, 'lecture_ref')
        elif eor_type == PRACTICAL:
            # Практическое занятие
            if currentTable.tryGet(package_id):
                practical_desc = getattr(currentTable, 'practical_descr')
                data['descr'] = unescapeHtml4(practical_desc) if practical_desc else ''  
                data['show_descr'] = '0'      
                data['files_pz'] = {'@delete_id': 0, '#sorted': []}     
                
                pr_filesCur = practical_filesCursor(context)
                pr_filesCur.setRange('task_id', task_id)
                for pr_file in pr_filesCur.iterate():
                    data['files_pz']['#sorted'].append({'file': {'@id': pr_file.id, '#text': pr_file.file_name}})
                 
                data['files_to_upload'] = ''      
                data['upload_started'] = 1      
                
                xformssettings = {"properties": {
                                    "event": [
                                        {"@name":"single_click",
                                         "@linkId": "1",
                                         "action":{
                                            "#sorted": [
                                                {"main_context": "current"},
                                                {"datapanel": {
                                                    "@type": "current",
                                                    "@tab": "current",
                                                    "element": {
                                                        "@id": elementId,
                                                        "add_context": "refresh"}}}]}},
                                        {"@name":"single_click",
                                         "@linkId": "delete",
                                         "action":{
                                            "#sorted": [
                                                {"main_context": "current"},
                                                {"datapanel": {
                                                    "@type": "current",
                                                    "@tab": "current",
                                                    "element": {
                                                        "@id": elementId,
                                                        "add_context": "delete"}}}]}}]}}                      
    
    xformsdata = {'schema': {  
                    '@xmlns':'',
                    'data': data}}
      
    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)), XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def taskSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение карточки. '''

    session = json.loads(session)
    sid = session['sessioncontext']['sid']
    
    main_jsn = json.loads(main)
    cycle_id = main_jsn['cycle_id']
#     certificate = main_jsn['certificate']  
      
    data = json.loads(xformsdata)['schema']['data']
    eor_type = int(data['eor_type'])    
    
    if eor_type == TEST:
        param = data['param']
        package_id = data['package_id']    
        person_id = data['person_id'] 
        
        # Если требуется создание теста
        if param == 'create':         
            # Проверка наполнения теста
            qti_theme = QtiThemeCursor(context)
            qti_question = QtiQuestionCursor(context)
            qti_destructor = QtiDestructorCursor(context)
            qti_theme.setRange('PackageID',package_id)
            count = 0
            errorText = ''
            emptyFlag = False
            for theme in qti_theme.iterate():
                qti_question.setRange('ThemeID',theme.ThemeID)
                count += qti_question.count()
                questionList = []
                for question in qti_question.iterate():
                    qti_destructor.setRange('QuestionID',question.QuestionID)
                    if qti_destructor.count() == 0:
                        questionList.append(str(question.QuestionOrder))
                if questionList:
                    errorText += u'В теме "%s" вопросы №%s не содержат вариантов ответа. '%(theme.ThemeName,','.join(questionList))
                    emptyFlag = True
            if count == 0:
                emptyFlag = True
                errorText = u'БТЗ не содержит вопросов'
                
            qti_theme.close()
            qti_question.close()
            qti_destructor.close()  
            
            # Если проверка не прошла, то сообщение об ошибке
            if emptyFlag:
                context.error(u"Тест недоступен. Попробуйте позднее.")
            
            # Создание информации о тесте
            params = {'NoRandom': 0,
                      'TimeTest': generalSettings.getGlobalSettings(context, 'TEST_TIME'),
                      'QuantityQuestions': generalSettings.getGlobalSettings(context, 'QUANTITY_QUESTIONS'),
                      'Percent3': 60,
                      'Percent4': 70,
                      'Percent5': 80,
                      'NoProtocol': 0,
                      'NoSelfTesting': 1}
            
            variant_id = data['variant_id']
            
            createTestingVariantAssign(context, variant_id, package_id, sid, person_id, params, cycle_id)
            # Генерация теста
            generateVariant(context, package_id, variant_id, debugFlag=False)
            
            setTestTimeByParam(context, variant_id)
            
#             QtiVariantParams = QtiVariantParamsCursor(context)
#             timeTest = int(getAttributeValue(QtiVariantParams, variant_id, 'TimeTest'))
#             QtiVariantParams.close()
#             
#             QtiVariantAnswer = QtiVariantAnswerCursor(context)
#             QtiVariantAnswer.VariantAnswerID = unicode(uuid4())
#             QtiVariantAnswer.VariantID = variant_id
#             timeBegin = Date()
#             QtiVariantAnswer.TimeBegin = timeBegin
#             QtiVariantAnswer.TimeEnd = Timestamp(timeBegin.getTime() + timeTest * 60 * 1000)
#             QtiVariantAnswer.insert()
#             QtiVariantAnswer.close()
            
            taskCur = student_eor_tasksCursor(context)
            task_id = data['task_id']
            if taskCur.tryGet(task_id) and taskCur.attempts_count > 0:
                
                QtiVariant = QtiVariantCursor(context)
                QtiVariant.get(variant_id)
                variant_name = QtiVariant.VariantName
                QtiVariant.close()
                
                taskCur.attempts_count -= 1
                taskCur.variant_id = variant_id
                taskCur.variant_name = variant_name
                taskCur.update()
    elif eor_type == PRACTICAL:
        if add == 'delete':
            file_id = int(data['files_pz']['@delete_id'])
            pr_filesCur = practical_filesCursor(context)
            if pr_filesCur.tryGet(file_id):
                pr_filesCur.delete()
            pr_filesCur.close()


def uploadTaskFile(context, main, add, filterinfo, session, elementId, xformsdata, fileName, file):
    u'''Процедура для скачивания файлов в специальную директорию'''
    session = json.loads(session)
    data = json.loads(xformsdata)['schema']['data']

    pr_filesCur = practical_filesCursor(context)
    pr_filesCur.init()
    pr_filesCur.task_id = int(data['task_id'])
    pr_filesCur.file_name = fileName
    
    pr_filesCur.calcfile_resource()
    osw = OutputStreamWriter(pr_filesCur.file_resource.getOutStream(), 'utf-8')
    try:
        while 1:
            onebyte = file.read()
            if onebyte == -1:
                break
            else:
                osw.append(chr(onebyte))
    finally:
        osw.close()    
    pr_filesCur.insert()
    